﻿using System.Data.SqlClient;

namespace Projekt.Framework
{
    public class Configuration
    {
        public string? Designation { get; set; }
        public string? Host { get; set; }
        public string? Database { get; set; }

        private string? _User;
        public string? User
        {
            set
            {
                if (!string.IsNullOrWhiteSpace(value))
                {
                    _User = value;
                    if (_password != null)
                    {
                        credentials = new SqlCredential(_User, _password);
                    }
                }
                else
                {
                    credentials = null;
                }
            }
        }

        private System.Security.SecureString? _password;
        public string? password
        {
            set
            {
                if (!string.IsNullOrWhiteSpace(value))
                {
                    _password = new System.Security.SecureString();
                    foreach (char c in value)
                    {
                        _password.AppendChar(c);
                    }
                    _password.MakeReadOnly();
                    if (!string.IsNullOrWhiteSpace(_User))
                    {
                        credentials = new SqlCredential(_User, _password);
                    }
                }
                else
                {
                    credentials = null;
                }
            }
        }

        public SqlCredential? credentials { get; set; }

        public string GetConnectionString()
        {
                SqlConnectionStringBuilder builder = new SqlConnectionStringBuilder(string.Concat("Data Source=", Host, ";Initial Catalog=", Database, ";"));
                builder.Remove("User ID");
                builder.Remove("Password");
                builder.IntegratedSecurity = credentials == null;
                return builder.ConnectionString;
        }
    }
}

